-- Testbench for fourbit_adder
-- A testbench is used to rigorously tests a design that you have made.
-- The output of the testbench should allow the designer to see if
-- the design worked.  The testbench should also report where the testbench
-- failed.

-- This is just to make a reference to some common things needed.

LIBRARY IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Declare a testbench. 
-- Note that the testbench does not have any input or output ports!

entity fourbit_adder_tb  is
end fourbit_adder_tb;

-- Describe the functionality of the tesbench.
architecture MY_TEST_ARCH of fourbit_adder_tb is 
  component fourbit_adder
    generic (
      WIDTH : positive := 4);
    port( 
      a, b: in STD_LOGIC_VECTOR(WIDTH-1 downto 0);
      s: out STD_LOGIC_VECTOR(WIDTH-1 downto 0);
      cout: out STD_LOGIC);
  end component;

  signal a, b: STD_LOGIC_VECTOR(3 downto 0);
  signal z: STD_LOGIC_VECTOR(3 downto 0);
  signal cout: STD_LOGIC;
  
  for DUT1: fourbit_adder use entity WORK.FOURBIT_ADDER(MY_STRUCTURAL);
  --for DUT1: fourbit_adder use entity WORK.FOURBIT_ADDER(MY_BEHAVIORAL1);
  --for DUT1: fourbit_adder use entity WORK.FOURBIT_ADDER(MY_BEHAVIORAL1);
  
  begin
    DUT1: fourbit_adder generic map (WIDTH => 4) port map (a=>a, b=>b, s=>z, cout=>cout);
  
    process
    begin
      -- Case 1 that we are testing.
      a <= "0000";
      b <= "0000";
      wait for 50 ns;
      assert ( z = "0000" ) report "Failed Case 1 - z" severity error;
      assert ( cout = '0' ) report "Failed Case 1 - cout" severity error;

      -- Case 2 that we are testing.
      a <= "1111";
      b <= "1111";
      wait for 50 ns;
      assert ( z = "1110" ) report "Failed Case 2 - z" severity error;
      assert ( cout = '1' ) report "Failed Case 2 - cout" severity error;

      -- Case 3 that we are testing.
      a <= "1111";
      b <= "0001";
      wait for 50 ns;
      assert ( z = "0000" ) report "Failed Case 2 - z" severity error;
      assert ( cout = '1' ) report "Failed Case 2 - cout" severity error;
    end process;
    
END MY_TEST_ARCH;